import argparse

import gettext
from gettext import gettext as _
gettext.textdomain('angajat')

import sys
import os
import string
import platform

from angajat import angajatconfig
from angajat.logic import *
from angajat.angajatculori import pc as pc
from angajat.angajatculori import pm as pm
from angajat.angajatculori import fs as fs

hf_vers=angajatconfig.__version__
hf_del_home=True

class create_callback(argparse.Action):
    def __call__(self, parser, namespace, values, option_string=None):
        print('--- '+_('Create User')+' ---').center(40)
        read_username()
        read_fullname()
        read_password()
        create_group()
        create_user()
        create_samba()

class delete_callback(argparse.Action):
    def __call__(self, parser, namespace, values, option_string=None):
        print('--- '+_('Delete User')+' ---').center(70)
        read_username()
        delete_samba()
        delete_user()
        if hf_del_home:
            delete_home()

class enable_callback(argparse.Action):
    def __call__(self, parser, namespace, values, option_string=None):
        print('--- '+_('Enable User')+' ---').center(70)
        read_username()
        enable_samba()

class disable_callback(argparse.Action):
    def __call__(self, parser, namespace, values, option_string=None):
        print('--- '+_('Disable User')+' ---').center(70)
        read_username()
        disable_samba()

class list_callback(argparse.Action):
    def __call__(self, parser, namespace, values, option_string=None):
        print('--- '+_('List Users')+' ---').center(70)
        list_users()


def main():
    if not i_am_linux():
        quit(pc(_("Wrong platform. you need to run GNU/Linux."), 'bred'))
    else:
        os.system('clear')

    print_hf()

    if not i_am_root():
        quit(pc(_("You need root/sudo privileges to run this application"), 'bred'))

    version = angajatconfig.__version__
    # Support for command line options.
    description = _("Manage employees on a NAS Server with Samba")
    parser = argparse.ArgumentParser(description, usage='')
    parser.add_argument('--version', action='version', version=version)
    parser.add_argument("-c", action=create_callback, nargs=0,
        help=_('Create a new employee account'))
    parser.add_argument("-x", action=delete_callback, nargs=0,
        help=_('Delete an existing employee'))
    parser.add_argument("-e", action=enable_callback, nargs=0,
        help=_("Enable an employee after a period of absence"))
    parser.add_argument("-d", action=disable_callback, nargs=0,
        help=_("Disable an employee after a period of absence"))
    parser.add_argument("-l", action=list_callback, nargs=0,
        help=_("Display a list of all users"))
    parser.set_defaults()
    args = parser.parse_args()

if __name__ == "__main__":
    main()
